Merge tag 'nfs-for-6.4-1' of git://git.linux-nfs.org/projects/anna/linux-nfs
[linux-block.git] / scripts / faddr2line
CommitLineData
67326666 1#!/bin/bash
b2441318 2# SPDX-License-Identifier: GPL-2.0
67326666
JP
3#
4# Translate stack dump function offsets.
5#
6# addr2line doesn't work with KASLR addresses. This works similarly to
7# addr2line, but instead takes the 'func+0x123' format as input:
8#
9# $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
10# meminfo_proc_show+0x5/0x568:
11# meminfo_proc_show at fs/proc/meminfo.c:27
12#
13# If the address is part of an inlined function, the full inline call chain is
14# printed:
15#
16# $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
17# native_write_msr+0x6/0x27:
18# arch_static_branch at arch/x86/include/asm/msr.h:121
19# (inlined by) static_key_false at include/linux/jump_label.h:125
20# (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
21#
22# The function size after the '/' in the input is optional, but recommended.
23# It's used to help disambiguate any duplicate symbol names, which can occur
24# rarely. If the size is omitted for a duplicate symbol then it's possible for
25# multiple code sites to be printed:
26#
27# $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
28# raw_ioctl+0x5/0x20:
29# raw_ioctl at drivers/char/raw.c:122
30#
31# raw_ioctl+0x5/0xb1:
32# raw_ioctl at net/ipv4/raw.c:876
33#
34# Multiple addresses can be specified on a single command line:
35#
36# $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
37# type_show+0x10/0x2d:
38# type_show at drivers/video/backlight/backlight.c:213
39#
40# free_reserved_area+0x90/0x123:
41# free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
42
43
44set -o errexit
45set -o nounset
46
67326666 47usage() {
689135f0 48 echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
67326666
JP
49 exit 1
50}
51
52warn() {
53 echo "$1" >&2
54}
55
56die() {
57 echo "ERROR: $1" >&2
58 exit 1
59}
60
1d1a0e7c
JP
61READELF="${CROSS_COMPILE:-}readelf"
62ADDR2LINE="${CROSS_COMPILE:-}addr2line"
63AWK="awk"
a41a2e2e 64GREP="grep"
1d1a0e7c
JP
65
66command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed"
67command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed"
68command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed"
69
67326666
JP
70# Try to figure out the source directory prefix so we can remove it from the
71# addr2line output. HACK ALERT: This assumes that start_kernel() is in
f5f67cc0 72# init/main.c! This only works for vmlinux. Otherwise it falls back to
67326666
JP
73# printing the absolute path.
74find_dir_prefix() {
75 local objfile=$1
76
2d77de15
SD
77 local start_kernel_addr=$(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' |
78 ${AWK} '$8 == "start_kernel" {printf "0x%s", $2}')
67326666
JP
79 [[ -z $start_kernel_addr ]] && return
80
95a87982 81 local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
67326666
JP
82 [[ -z $file_line ]] && return
83
84 local prefix=${file_line%init/main.c:*}
85 if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
86 return
87 fi
88
89 DIR_PREFIX=$prefix
90 return 0
91}
92
93__faddr2line() {
94 local objfile=$1
95 local func_addr=$2
96 local dir_prefix=$3
97 local print_warnings=$4
98
1d1a0e7c 99 local sym_name=${func_addr%+*}
dcea997b
JP
100 local func_offset=${func_addr#*+}
101 func_offset=${func_offset%/*}
1d1a0e7c 102 local user_size=
dcea997b
JP
103 local file_type
104 local is_vmlinux=0
1d1a0e7c 105 [[ $func_addr =~ "/" ]] && user_size=${func_addr#*/}
67326666 106
dcea997b 107 if [[ -z $sym_name ]] || [[ -z $func_offset ]] || [[ $sym_name = $func_addr ]]; then
67326666
JP
108 warn "bad func+offset $func_addr"
109 DONE=1
110 return
111 fi
112
dcea997b
JP
113 # vmlinux uses absolute addresses in the section table rather than
114 # section offsets.
115 local file_type=$(${READELF} --file-header $objfile |
116 ${AWK} '$1 == "Type:" { print $2; exit }')
b6a50688
JP
117 if [[ $file_type = "EXEC" ]] || [[ $file_type == "DYN" ]]; then
118 is_vmlinux=1
119 fi
dcea997b 120
67326666 121 # Go through each of the object's symbols which match the func name.
1d1a0e7c
JP
122 # In rare cases there might be duplicates, in which case we print all
123 # matches.
124 while read line; do
125 local fields=($line)
126 local sym_addr=0x${fields[1]}
127 local sym_elf_size=${fields[2]}
128 local sym_sec=${fields[6]}
dcea997b
JP
129 local sec_size
130 local sec_name
1d1a0e7c
JP
131
132 # Get the section size:
dcea997b 133 sec_size=$(${READELF} --section-headers --wide $objfile |
1d1a0e7c
JP
134 sed 's/\[ /\[/' |
135 ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }')
136
137 if [[ -z $sec_size ]]; then
138 warn "bad section size: section: $sym_sec"
139 DONE=1
140 return
141 fi
142
dcea997b
JP
143 # Get the section name:
144 sec_name=$(${READELF} --section-headers --wide $objfile |
145 sed 's/\[ /\[/' |
146 ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print $2; exit }')
147
148 if [[ -z $sec_name ]]; then
149 warn "bad section name: section: $sym_sec"
150 DONE=1
151 return
152 fi
153
1d1a0e7c
JP
154 # Calculate the symbol size.
155 #
156 # Unfortunately we can't use the ELF size, because kallsyms
157 # also includes the padding bytes in its size calculation. For
158 # kallsyms, the size calculation is the distance between the
159 # symbol and the next symbol in a sorted list.
160 local sym_size
161 local cur_sym_addr
162 local found=0
163 while read line; do
164 local fields=($line)
165 cur_sym_addr=0x${fields[1]}
166 local cur_sym_elf_size=${fields[2]}
167 local cur_sym_name=${fields[7]:-}
168
169 if [[ $cur_sym_addr = $sym_addr ]] &&
170 [[ $cur_sym_elf_size = $sym_elf_size ]] &&
171 [[ $cur_sym_name = $sym_name ]]; then
172 found=1
173 continue
174 fi
175
176 if [[ $found = 1 ]]; then
177 sym_size=$(($cur_sym_addr - $sym_addr))
178 [[ $sym_size -lt $sym_elf_size ]] && continue;
179 found=2
180 break
181 fi
2d77de15 182 done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2)
1d1a0e7c
JP
183
184 if [[ $found = 0 ]]; then
185 warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size"
186 DONE=1
187 return
188 fi
189
190 # If nothing was found after the symbol, assume it's the last
191 # symbol in the section.
192 [[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr))
193
efdb4167 194 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
1d1a0e7c 195 warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr"
efdb4167
JP
196 DONE=1
197 return
198 fi
1d1a0e7c 199
efdb4167 200 sym_size=0x$(printf %x $sym_size)
67326666 201
dcea997b
JP
202 # Calculate the address from user-supplied offset:
203 local addr=$(($sym_addr + $func_offset))
67326666 204 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
dcea997b 205 warn "bad address: $sym_addr + $func_offset"
67326666
JP
206 DONE=1
207 return
208 fi
efdb4167 209 addr=0x$(printf %x $addr)
67326666 210
1d1a0e7c
JP
211 # If the user provided a size, make sure it matches the symbol's size:
212 if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then
67326666 213 [[ $print_warnings = 1 ]] &&
1d1a0e7c 214 echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)"
67326666
JP
215 continue;
216 fi
217
1d1a0e7c 218 # Make sure the provided offset is within the symbol's range:
dcea997b 219 if [[ $func_offset -gt $sym_size ]]; then
67326666 220 [[ $print_warnings = 1 ]] &&
dcea997b 221 echo "skipping $sym_name address at $addr due to size mismatch ($func_offset > $sym_size)"
67326666
JP
222 continue
223 fi
224
1d1a0e7c
JP
225 # In case of duplicates or multiple addresses specified on the
226 # cmdline, separate multiple entries with a blank line:
67326666
JP
227 [[ $FIRST = 0 ]] && echo
228 FIRST=0
229
dcea997b 230 echo "$sym_name+$func_offset/$sym_size:"
6870c016 231
1d1a0e7c
JP
232 # Pass section address to addr2line and strip absolute paths
233 # from the output:
dcea997b
JP
234 local args="--functions --pretty-print --inlines --exe=$objfile"
235 [[ $is_vmlinux = 0 ]] && args="$args --section=$sec_name"
236 local output=$(${ADDR2LINE} $args $addr | sed "s; $dir_prefix\(\./\)*; ;")
1d1a0e7c
JP
237 [[ -z $output ]] && continue
238
239 # Default output (non --list):
689135f0 240 if [[ $LIST = 0 ]]; then
1d1a0e7c 241 echo "$output" | while read -r line
689135f0
PZI
242 do
243 echo $line
244 done
245 DONE=1;
1d1a0e7c 246 continue
689135f0
PZI
247 fi
248
1d1a0e7c
JP
249 # For --list, show each line with its corresponding source code:
250 echo "$output" | while read -r line
6870c016 251 do
689135f0 252 echo
6870c016 253 echo $line
78eb0c63
CD
254 n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
255 n1=$[$n-5]
256 n2=$[$n+5]
257 f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
1d1a0e7c 258 ${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
6870c016
CD
259 done
260
67326666
JP
261 DONE=1
262
2d77de15 263 done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v fn=$sym_name '$4 == "FUNC" && $8 == fn')
67326666
JP
264}
265
266[[ $# -lt 2 ]] && usage
267
268objfile=$1
689135f0
PZI
269
270LIST=0
271[[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
272
67326666
JP
273[[ ! -f $objfile ]] && die "can't find objfile $objfile"
274shift
275
a41a2e2e
JP
276${READELF} --section-headers --wide $objfile | ${GREP} -q '\.debug_info' || die "CONFIG_DEBUG_INFO not enabled"
277
67326666
JP
278DIR_PREFIX=supercalifragilisticexpialidocious
279find_dir_prefix $objfile
280
281FIRST=1
282while [[ $# -gt 0 ]]; do
283 func_addr=$1
284 shift
285
286 # print any matches found
287 DONE=0
288 __faddr2line $objfile $func_addr $DIR_PREFIX 0
289
290 # if no match was found, print warnings
291 if [[ $DONE = 0 ]]; then
292 __faddr2line $objfile $func_addr $DIR_PREFIX 1
293 warn "no match for $func_addr"
294 fi
295done